// DrwGLDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DrwGLDemo.h"
#include "DrwGLDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDrwGLDemoDlg dialog

CDrwGLDemoDlg::CDrwGLDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDrwGLDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDrwGLDemoDlg)
	m_bDrawExample = FALSE;
	m_bShowinfoWindow = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
  m_lPrimitiveIndex = 0;
  m_dCoordinateX = 0;
  m_dCoordinateY = 0;
  m_dCoordinateZ = 0;
}

void CDrwGLDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDrwGLDemoDlg)
	DDX_Control(pDX, IDC_DRWGLCOMCTRL1, m_DrwGL);
	DDX_Check(pDX, IDC_CHECK_DRAW_EXAMPLE, m_bDrawExample);
	DDX_Check(pDX, IDC_CHECK_INFO_WINDOW, m_bShowinfoWindow);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDrwGLDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDrwGLDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CHECK_DRAW_EXAMPLE, OnDrawExample)
	ON_BN_CLICKED(IDC_BUTTON_XY_NEGATIVE, OnButtonXY_Negative)
	ON_BN_CLICKED(IDC_BUTTON_YZ_POSITIVE, OnButtonYZ_Positive)
	ON_BN_CLICKED(IDC_BUTTON_YZ_NEGATIVE, OnButtonYZ_Negative)
	ON_BN_CLICKED(IDC_BUTTON_ZX_POSITIVE, OnButtonZX_Positive)
	ON_BN_CLICKED(IDC_MODE, OnMode)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_CHECK_INFO_WINDOW, OnShowInfoWindow)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrwGLDemoDlg message handlers

BOOL CDrwGLDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	GetVars();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDrwGLDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDrwGLDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDrwGLDemoDlg::OnDrawExample() 
{
	// TODO: Add your control notification handler code here
	if(!UpdateData())
		return;

  if (m_bDrawExample)
    m_DrwGL.DrawTest();
  else 
  {
    m_DrwGL.BeginDraw();
    m_DrwGL.Invalidate();
  }
}



void CDrwGLDemoDlg::OnButtonXY_Negative() 
{
	// TODO: Add your control notification handler code here
	m_DrwGL.DrawLineTo(++m_lPrimitiveIndex, m_dCoordinateX-=10, 
                     m_dCoordinateY-=10, m_dCoordinateZ, 1);
	
}

void CDrwGLDemoDlg::OnButtonYZ_Positive() 
{
	// TODO: Add your control notification handler code here
	m_DrwGL.DrawLineTo(++m_lPrimitiveIndex, m_dCoordinateX, 
                     m_dCoordinateY+=10, m_dCoordinateZ+=10, 1);
	
}

void CDrwGLDemoDlg::OnButtonYZ_Negative() 
{
	// TODO: Add your control notification handler code here
	m_DrwGL.DrawLineTo(++m_lPrimitiveIndex, m_dCoordinateX, 
                     m_dCoordinateY-=10, m_dCoordinateZ-=10, 1);
	
}

void CDrwGLDemoDlg::OnButtonZX_Positive() 
{
	// TODO: Add your control notification handler code here
	m_DrwGL.DrawLineTo(++m_lPrimitiveIndex, m_dCoordinateX+=10, 
                     m_dCoordinateY, m_dCoordinateZ+=10, 1);
}

void CDrwGLDemoDlg::OnMode() 
{
	// TODO: Add your control notification handler code here
	m_DrwGL.ChangeMode();
}

void CDrwGLDemoDlg::OnClear() 
{
	// TODO: Add your control notification handler code here
  m_bDrawExample = 0;
	UpdateData(FALSE);

  m_DrwGL.BeginDraw();
  m_DrwGL.Invalidate();
}

void CDrwGLDemoDlg::GetVars()
{
  m_bDrawExample = 1;
  m_bShowinfoWindow = m_DrwGL.GetBEnableShowInfoWindow();
	UpdateData(FALSE);
}

void CDrwGLDemoDlg::OnShowInfoWindow() 
{
	// TODO: Add your control notification handler code here
	if(!UpdateData())
		return;

  m_DrwGL.SetBEnableShowInfoWindow(m_bShowinfoWindow);
}
